
fcinv MACRO algo, a1, a2, a3, a4, a5, a6
LOCAL invAlgo$, out$, Description, movreg1, movreg2, movreg3
  invAlgo$ CATSTR <invoke >, <algo>
  ifidn <?>, <algo>
	include \masm32\macros\macrohlp.inc	;; [url=\masm32\include\macrohlp.inc]open[/url]
	showhelp fcinv
	invAlgo$ equ <>
  endif
  movreg1 equ <>
  movreg2 equ <>
  movreg3 equ <>
  ifnb <a1>
	movreg1 equ CrtMovReg(a1)
	ifb movreg1
		invAlgo$ CATSTR invAlgo$, <, >, <a1>
	endif
  ifnb <a2>
	movreg2 equ CrtMovReg(a2)
	ifb movreg2
		invAlgo$ CATSTR invAlgo$, <, >, <a2>
	endif
  ifnb <a3>
	movreg3 equ CrtMovReg(a3)
	ifb movreg3
		invAlgo$ CATSTR invAlgo$, <, >, <a3>
	endif
  ifnb <a4>
	invAlgo$ CATSTR invAlgo$, <, >, <a4>
  ifnb <a5>
	invAlgo$ CATSTR invAlgo$, <, >, <a5>
  endif
  endif
  endif
  endif
  endif
  movreg1		;; mov eax, offset arg1 (for example)
  movreg2		;; mov ecx, offset arg2
  movreg3		;; mov edx, offset arg3
  ; .err
;;   % echo invAlgo$	; uncomment in case of problems
  invAlgo$		;; invoke MyAlgo, arg4, arg5, arg6
ENDM

;	Usage:
;	showcycles InString, 1, addr MainString, addr SubString
;	showcycles FcDemo2Regs, ecx:82, edx:offset MainString, addr SubString	; the FASTCALL variant

CrtMovReg MACRO arg
LOCAL src$, ado$, var$, sc
  if @InStr(1, <arg>, <:>) eq 4
;  	echo A=<arg>
	src$ SUBSTR <arg>, 5
;  	% echo S=src$
  	% sc SIZESTR <src$>
	if sc gt 5
;		echo GREATER
		ado$ SUBSTR src$, 1, 4
;		% echo AD=<ado$>
		ifidni ado$, <addr>
			var$ SUBSTR src$, 6
;			% echo Local=var$
			oa = (opattr var$) AND 127
			if oa eq 98
				MovReg$ CATSTR <lea >, @SubStr(<arg>, 1, 3), <, >, var$
;				% echo CM=MovReg$
			else
				MovReg$ CATSTR <mov >, @SubStr(<arg>, 1, 3), <, offset >, var$
			endif
		else
			MovReg$ CATSTR <mov >, @SubStr(<arg>, 1, 3), <, >, @SubStr(<arg>, 5)
		endif
	else
;		echo smaller
		MovReg$ CATSTR <mov >, @SubStr(<arg>, 1, 3), <, >, @SubStr(<arg>, 5)
	endif
;	% echo MR=MovReg$
;	 .err
	EXITM <MovReg$>
  else
	EXITM <>
  endif
ENDM

showcycles MACRO algo, a1, a2, a3, a4, a5, a6
LOCAL invAlgo$, out$, Description, movreg1, movreg2, movreg3
  invAlgo$ CATSTR <invoke >, <algo>
  ifidn <?>, <algo>
	include \masm32\macros\macrohlp.inc	;; [url=\masm32\include\macrohlp.inc]open[/url]
	showhelp showcycles
	invAlgo$ equ <>
  endif
  movreg1 equ <>
  movreg2 equ <>
  movreg3 equ <>
  ifndef LOOP_COUNT
	LOOP_COUNT = 1000000/10	;; default: one Million
  endif
  ifndef CurAlgo
  	CurAlgo equ <>
  endif
  ifdif CurAlgo, <algo>
  	CurAlgo equ <algo>
  endif

  Description equ <CurAlgo>
  ifnb <a1>
  	movreg1 equ CrtMovReg(a1)
	ifb movreg1
		invAlgo$ CATSTR invAlgo$, <, >, <a1>
	endif
	Description CATSTR Description, <, >, <a1>

  ifnb <a2>
  	movreg2 equ CrtMovReg(a2)
	ifb movreg2
		invAlgo$ CATSTR invAlgo$, <, >, <a2>
	endif
	Description CATSTR Description, <, >, <a2>
  ifnb <a3>
  	movreg3 equ CrtMovReg(a3)
	ifb movreg3
		invAlgo$ CATSTR invAlgo$, <, >, <a3>
	endif
	Description CATSTR Description, <, >, <a3>
  ifnb <a4>
	invAlgo$ CATSTR invAlgo$, <, >, <a4>
	Description CATSTR Description, <, >, <a4>
  ifnb <a5>
	invAlgo$ CATSTR invAlgo$, <, >, <a5>
	Description CATSTR Description, <, >, <a5>
  endif
  endif
  endif
  endif
  endif
  ifndef globcycles		;; we might need to calculate a global average count
  	.data?
  	globcycles	dd ?
  	globcount	dd ?
  	.code
  endif
  ifndef REP_CT
	REP_CT = 1
  endif
  ifndef REP_CTold
	REP_CTold = REP_CT
  endif
  if REP_CT gt 1
  	if REP_CTold eq 1
  		pushad
		print chr$(13, 10)
		popad
	endif
	REP_CTold = REP_CT
  endif
  ;% echo invAlgo$			;; uncomment to see what exactly you are invoking
  REPEAT REP_CT
	pushad
	invoke Sleep, 50
	popad
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		movreg1
		movreg2
		movreg3
		invAlgo$
	counter_end
	add globcycles, eax
	inc globcount
	out$ CATSTR <print str$(eax), 9, ">, Description, <", 13, 10>
	out$
  ENDM
  if REP_CT gt 1
	print chr$(13, 10)
  endif
ENDM
